package com.eeviewpoint;

import java.util.*;
import java.net.URL;
import javax.swing.text.html.HTMLEditorKit.ParserCallback;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.IOException;
import javax.swing.text.html.parser.ParserDelegator;

public class EnergyHarvester extends ParserDelegator{
    private Map scraperMap = new HashMap();
    private String  priceType = "";

    public EnergyHarvester(Map scraperMap) {
        this.scraperMap = scraperMap;
    }

    public EnergyHarvester() {
        scraperMap.put("oil","com.eeviewpoint.OilpriceCallback");
        scraperMap.put("fuel","com.eeviewpoint.GaspriceCallback");
        scraperMap.put("propane","com.eeviewpoint.PropanepriceCallback");
    }

    public String getPriceType() {
        return priceType;
    }

    public void setPriceType(String priceType) {
        this.priceType = priceType;
    }

    public String getNugget() throws ClassNotFoundException,
            IllegalAccessException, InstantiationException, IOException {
        String nm = ((String)scraperMap.get(priceType));
        ParserCallback callback = (ParserCallback) Class.forName(nm).newInstance();
        URL eia = new URL(
               ((Scraper) callback).getUrlSource());
        BufferedReader webPagestream = new BufferedReader(new InputStreamReader(eia.
                openStream()));
        super.parse(webPagestream,callback,true);
        return callback.toString();
    }

    public static void main(String[] args) throws IllegalAccessException, IOException,
            InstantiationException, ClassNotFoundException {
        EnergyHarvester harv = new EnergyHarvester();
        harv.setPriceType("propane");
        System.out.println(harv.getNugget());
    }
}
