package com.parkerriver;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.ServletException;
import java.io.IOException;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.URL;
import java.net.HttpURLConnection;
import org.apache.commons.betwixt.XMLUtils;

public class WeatherServlet extends HttpServlet {
    private static String weatherSearch = "http://xoap.weather.com/weather/local/";
    private static String addressSearch="http://xoap.weather.com/search/search?where=";
    protected void doGet(HttpServletRequest httpServletRequest,
                         HttpServletResponse httpServletResponse) throws ServletException, IOException {
        /*received querystring looks like:
       http://www.parkerriver.com/s/weathxml/weatherSearch?locid=30066&cc=*&dayf=2&prod=xoap&par=1012144868&key=67f74aa9fd9cc0e2
        http://xoap.weather.com/weather/local/30066?cc=*&dayf=2&prod=xoap&par=partId&key=licId*/
        String pathInfo =  httpServletRequest.getPathInfo();
        String url = null;
        String place = null;
        if(pathInfo == null) { throw new ServletException("This server component needs more information in the URL parameters.");}
        if(pathInfo.equalsIgnoreCase("/weatherSearch")) {
            url = weatherSearch+httpServletRequest.getParameter("locId")+
                    "?cc=*&dayf=2&prod=xoap&par="+
                    httpServletRequest.getParameter("par")+
                    "&key="+httpServletRequest.getParameter("licId");

            httpServletResponse.setContentType("text/xml; charset=UTF-8");
            httpServletResponse.getWriter().write(weatherXmlSearch(url));
        }  else if (pathInfo.equalsIgnoreCase("/addressSearch")) {
            place =  httpServletRequest.getParameter("city");
            if(place != null){
                url = addressSearch+java.net.URLEncoder.encode(place,"UTF-8");
                httpServletResponse.setContentType("text/xml; charset=UTF-8");
                httpServletResponse.getWriter().write( weatherXmlSearch(url));
            }  else {  AjaxUtil.sendXML(httpServletResponse, "<info>"+
                    XMLUtils.escapeBodyValue(pathInfo)+"</info>");}
        }   else {
            AjaxUtil.sendXML(httpServletResponse, "<info>"+
                    XMLUtils.escapeBodyValue(pathInfo)+"</info>");
        }

    }

    protected void doPost(HttpServletRequest httpServletRequest,
                          HttpServletResponse httpServletResponse) throws ServletException, IOException {
        doGet(httpServletRequest,httpServletResponse);
    }

    private String weatherXmlSearch(String _url) throws IOException {
        URL wcomUrl = new URL(_url);

        HttpURLConnection htUrl = (HttpURLConnection) wcomUrl.openConnection();
        htUrl.setDoInput(true);
        htUrl.setRequestMethod("GET");
        BufferedReader in = new BufferedReader(
                new InputStreamReader(
                        htUrl.getInputStream()));
        StringBuffer buf = new StringBuffer("");
        String inputLine;

        while ((inputLine = in.readLine()) != null) {
            buf.append(inputLine);   }
        in.close();
        return buf.toString();
    }

}
